import { IdentityFn, MakeRequired, RSA, RSN } from "./utils";
import type { Validate } from "./validate";
declare type CallOptions<Type, Options> = Partial<Options extends RSN ? ExtraOptions<Type, Options> : Options & Omit<ExtraOptions<Type, Options>, keyof Options>>;
export declare type Guard<Type, Options extends RSA = RSN> = Validate<Type> & ((options: CallOptions<Type, Options>) => Validate<Type>);
export declare type GuardOptions<Name extends keyof vality.guards, G = vality.guards[Name]> = G extends Guard<infer Type, infer Options> ? [Type, Options] : G extends (...args: any[]) => Guard<infer Type, infer Options> ? [Type, Options] : never;
declare type ExtraOptions<T, O> = {
    transform: IdentityFn<T>;
    default: T;
    validate: (val: T, options: CallOptions<T, O>) => boolean;
};
export declare function guard<Name extends keyof vality.guards, Type extends GuardOptions<Name>[0], Options extends RSA & GuardOptions<Name>[1]>(name: Name, fn: (val: unknown, options: CallOptions<Type, Options>) => Type | undefined, handleOptions?: {
    [K in Exclude<keyof Options, keyof ExtraOptions<Type, Options>>]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K> & Partial<ExtraOptions<Type, Options>>) => boolean;
}, defaultOptions?: Partial<Options>): Guard<Type, Options>;
export {};
